-------------------------------------------------------------------------
-- CacheDictionary
--
-- $Id: CacheDictionary.lua,v
-------------------------------------------------------------------------
LUA_PATH = "./?.lua;./LuaClass/?.lua"
require "LuaClass"

-- Class name declarations.
begin_declare()
declare("CacheDictionary")
declare("CachedBuffer")


-------------------------------------------------------------------------
-- LbVp̎
-------------------------------------------------------------------------
CacheDictionary = { "CacheDictionary", "MappedCollection"; }

	-- checkCache : VKLbVǉɌĂ΂R[obN
	function CacheDictionary:init( checkCache )
		self:super()
		self.mData = Array()
		self.mCheckCache = checkCache
	end

	function CacheDictionary:add( _key, _value )
		local index = self.mData:foreach(
			function ( i, v )
				if v.key == _key then return i end
			end
		)
		
		if index then
			-- łɃLbVo^ς݂ȂU폜Ė
			self.mData:remove( index )
		else
			-- VKLbV
			self.mCheckCache( self )
		end
		-- ֑}
		self.mData:add( { key = _key, value = _value } )
	end

	function CacheDictionary:remove( _key )
		findAndRemove = function ( i, v )
			if v.key == _key then
				return self.mData:remove( i )
			end
		end
		return self.mData:foreach( findAndRemove )
	end

	function CacheDictionary:at( _key )
		find = function ( i, v )
			if v.key == _key then return v.value end
		end
		return self.mData:foreach( find )
	end

	function CacheDictionary:size()
		return self.mData:size()
	end

	function CacheDictionary:foreach( fn )
		return self.mData:foreach(
			function ( i, v ) fn( v.value ) end
		)
	end

Class:new( CacheDictionary )



-------------------------------------------------------------------------
-- end of file
-------------------------------------------------------------------------
end_declare()